pcl::SampleConsensusModelPerpendicularPlane< PointT > Class Template Reference
Module sample_consensus

SampleConsensusModelPerpendicularPlane defines a model for 3D plane segmentation using additional angular constraints. More...

`#include <pcl/sample_consensus/sac_model_perpendicular_plane.h>`

Inheritance diagram for pcl::SampleConsensusModelPerpendicularPlane< PointT >:

## Public Types

using | PointCloud = typename SampleConsensusModelPlane< PointT >::PointCloud
using | PointCloudPtr = typename SampleConsensusModelPlane< PointT >::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModelPlane< PointT >::PointCloudConstPtr
using | Ptr = shared_ptr< SampleConsensusModelPerpendicularPlane< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModelPerpendicularPlane< PointT > >
Public Types inherited from pcl::SampleConsensusModelPlane< PointT >
using | PointCloud = typename SampleConsensusModel< PointT >::PointCloud
using | PointCloudPtr = typename SampleConsensusModel< PointT >::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel< PointT >::PointCloudConstPtr
using | Ptr = shared_ptr< SampleConsensusModelPlane< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModelPlane< PointT > >
Public Types inherited from pcl::SampleConsensusModel< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointCloudPtr = typename PointCloud::Ptr
using | SearchPtr = typename pcl::search::Search< PointT >::Ptr
using | Ptr = shared_ptr< SampleConsensusModel< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModel< PointT > >

## Public Member Functions

| SampleConsensusModelPerpendicularPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelPerpendicularPlane. More...
| SampleConsensusModelPerpendicularPlane (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModelPerpendicularPlane. More...
| ~SampleConsensusModelPerpendicularPlane ()
| Empty destructor. More...
void | setAxis (const Eigen::Vector3f &ax)
| Set the axis along which we need to search for a plane perpendicular to. More...
Eigen::Vector3f | getAxis () const
| Get the axis along which we need to search for a plane perpendicular to. More...
void | setEpsAngle (const double ea)
| Set the angle epsilon (delta) threshold. More...
double | getEpsAngle () const
| Get the angle epsilon (delta) threshold. More...
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, Indices &inliers) override
| Select all the points which respect the given model coefficients as inliers. More...
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers. More...
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all distances from the cloud data to a given plane model. More...
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_PERPENDICULAR_PLANE). More...
Public Member Functions inherited from pcl::SampleConsensusModelPlane< PointT >
| SampleConsensusModelPlane (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelPlane. More...
| SampleConsensusModelPlane (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModelPlane. More...
| ~SampleConsensusModelPlane ()
| Empty destructor. More...
bool | computeModelCoefficients (const Indices &samples, Eigen::VectorXf &model_coefficients) const override
| Check whether the given index samples can form a valid plane model, compute the model coefficients from these samples and store them internally in model_coefficients_. More...
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all distances from the cloud data to a given plane model. More...
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, Indices &inliers) override
| Select all the points which respect the given model coefficients as inliers. More...
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers. More...
void | optimizeModelCoefficients (const Indices &inliers, const Eigen::VectorXf &model_coefficients, Eigen::VectorXf &optimized_coefficients) const override
| Recompute the plane coefficients using the given inlier set and return them to the user. More...
void | projectPoints (const Indices &inliers, const Eigen::VectorXf &model_coefficients, PointCloud &projected_points, bool copy_data_fields=true) const override
| Create a new point cloud with inliers projected onto the plane model. More...
bool | doSamplesVerifyModel (const std::set< index_t > &indices, const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Verify whether a subset of indices verifies the given plane model coefficients. More...
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_PLANE). More...
Public Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModel. More...
| SampleConsensusModel (const PointCloudConstPtr &cloud, const Indices &indices, bool random=false)
| Constructor for base SampleConsensusModel. More...
virtual | ~SampleConsensusModel ()
| Destructor for base SampleConsensusModel. More...
virtual void | getSamples (int &iterations, Indices &samples)
| Get a set of random data samples and return them as point indices. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const Indices &indices)
| Provide the vector of indices that represents the input data. More...
IndicesPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
unsigned int | getSampleSize () const
| Return the size of a sample from which the model is computed. More...
unsigned int | getModelSize () const
| Return the number of coefficients in the model. More...
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius) More...
void | getRadiusLimits (double &min_radius, double &max_radius) const
| Get the minimum and maximum allowable radius limits for the model as set by the user. More...
void | setModelConstraints (std::function< bool(const Eigen::VectorXf &)> function)
| This can be used to impose any kind of constraint on the model, e.g. More...
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples. More...
void | getSamplesMaxDist (double &radius) const
| Get maximum distance allowed when drawing random samples. More...
double | computeVariance (const std::vector< double > &error_sqr_dists) const
| Compute the variance of the errors to the model. More...
double | computeVariance () const
| Compute the variance of the errors to the model from the internally estimated vector of distances. More...

## Protected Member Functions

bool | isModelValid (const Eigen::VectorXf &model_coefficients) const override
| Check whether a model is valid given the user constraints. More...
Protected Member Functions inherited from pcl::SampleConsensusModelPlane< PointT >
std::size_t | countWithinDistanceStandard (const Eigen::VectorXf &model_coefficients, const double threshold, std::size_t i=0) const
| This implementation uses no SIMD instructions. More...
Protected Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (bool random=false)
| Empty constructor for base SampleConsensusModel. More...
void | drawIndexSample (Indices &sample)
| Fills a sample array with random samples from the indices_ vector. More...
void | drawIndexSampleRadius (Indices &sample)
| Fills a sample array with one random sample from the indices_ vector and other random samples that are closer than samples_radius_. More...
int | rnd ()
| Boost-based random number generator. More...

## Protected Attributes

Eigen::Vector3f | axis_
| The axis along which we need to search for a plane perpendicular to. More...
double | eps_angle_
| The maximum allowed difference between the plane normal and the given axis. More...
Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
std::string | model_name_
| The model name. More...
PointCloudConstPtr | input_
| A boost shared pointer to the point cloud data array. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
double | radius_min_
| The minimum and maximum radius limits for the model. More...
double | radius_max_
double | samples_radius_
| The maximum distance of subsequent samples from the first (radius search) More...
SearchPtr | samples_radius_search_
| The search object for picking subsequent samples using radius search. More...
Indices | shuffled_indices_
| Data containing a shuffled version of the indices. More...
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm. More...
std::shared_ptr< boost::uniform_int<> > | rng_dist_
| Boost-based random number generator distribution. More...
std::shared_ptr< boost::variate_generator< boost::mt19937 &, boost::uniform_int<> > > | rng_gen_
| Boost-based random number generator. More...
std::vector< double > | error_sqr_dists_
| A vector holding the distances to the computed model. More...
unsigned int | sample_size_
| The size of a sample from which the model is computed. More...
unsigned int | model_size_
| The number of coefficients in the model. More...
std::function< bool(const Eigen::VectorXf &)> | custom_model_constraints_
| A user defined function that takes model coefficients and returns whether the model is acceptable or not. More...

## Additional Inherited Members

Static Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
static const unsigned int | max_sample_checks_ = 1000
| The maximum number of samples to try until we get a good one. More...

## Detailed Description

### template<typename PointT>
class pcl::SampleConsensusModelPerpendicularPlane< PointT >

SampleConsensusModelPerpendicularPlane defines a model for 3D plane segmentation using additional angular constraints.

The plane must be perpendicular to a user-specified axis (setAxis), up to a user-specified angle threshold (setEpsAngle). In other words, the plane normal must be (nearly) parallel to the specified axis. The model coefficients are defined as:

- a : the X coordinate of the plane's normal (normalized)
- b : the Y coordinate of the plane's normal (normalized)
- c : the Z coordinate of the plane's normal (normalized)
- d : the fourth Hessian component of the plane's equation

Code example for a plane model, perpendicular (within a 15 degrees tolerance) with the Z axis:

SampleConsensusModelPerpendicularPlane<pcl::PointXYZ> model (cloud);
model.setAxis (Eigen::Vector3f (0.0, 0.0, 1.0));
model.setEpsAngle (pcl::deg2rad (15));
pcl::deg2rad
float deg2rad(float alpha)
Convert an angle from degrees to radians.
Definition: angles.hpp:67

Note
  Please remember that you need to specify an angle > 0 in order to activate the axis-angle constraint!

Author
  Radu B. Rusu

Definition at line 70 of file sac_model_perpendicular_plane.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT >

using pcl::SampleConsensusModelPerpendicularPlane< PointT >::ConstPtr = shared_ptr<const SampleConsensusModelPerpendicularPlane<PointT> >

Definition at line 80 of file sac_model_perpendicular_plane.h.

## PointCloud

template<typename PointT >

using pcl::SampleConsensusModelPerpendicularPlane< PointT >::PointCloud = typename SampleConsensusModelPlane<PointT>::PointCloud

Definition at line 75 of file sac_model_perpendicular_plane.h.

## PointCloudConstPtr

template<typename PointT >

using pcl::SampleConsensusModelPerpendicularPlane< PointT >::PointCloudConstPtr = typename SampleConsensusModelPlane<PointT>::PointCloudConstPtr

Definition at line 77 of file sac_model_perpendicular_plane.h.

## PointCloudPtr

template<typename PointT >

using pcl::SampleConsensusModelPerpendicularPlane< PointT >::PointCloudPtr = typename SampleConsensusModelPlane<PointT>::PointCloudPtr

Definition at line 76 of file sac_model_perpendicular_plane.h.

## Ptr

template<typename PointT >

using pcl::SampleConsensusModelPerpendicularPlane< PointT >::Ptr = shared_ptr<SampleConsensusModelPerpendicularPlane<PointT> >

Definition at line 79 of file sac_model_perpendicular_plane.h.

## Constructor & Destructor Documentation

## SampleConsensusModelPerpendicularPlane() [1/2]

template<typename PointT >

pcl::SampleConsensusModelPerpendicularPlane< PointT >::SampleConsensusModelPerpendicularPlane | ( | const PointCloudConstPtr & | cloud,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelPerpendicularPlane.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 86 of file sac_model_perpendicular_plane.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## SampleConsensusModelPerpendicularPlane() [2/2]

template<typename PointT >

pcl::SampleConsensusModelPerpendicularPlane< PointT >::SampleConsensusModelPerpendicularPlane | ( | const PointCloudConstPtr & | cloud,
|  | const Indices & | indices,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelPerpendicularPlane.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | indices | a vector of point indices to be used from cloud
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 102 of file sac_model_perpendicular_plane.h.

References pcl::SampleConsensusModel< PointT >::model_name_, pcl::SampleConsensusModel< PointT >::model_size_, and pcl::SampleConsensusModel< PointT >::sample_size_.

## ~SampleConsensusModelPerpendicularPlane()

template<typename PointT >

pcl::SampleConsensusModelPerpendicularPlane< PointT >::~SampleConsensusModelPerpendicularPlane | ( |  | ) |

inline

Empty destructor.

Definition at line 115 of file sac_model_perpendicular_plane.h.

## Member Function Documentation

## countWithinDistance()

template<typename PointT >

std::size_t pcl::SampleConsensusModelPerpendicularPlane< PointT >::countWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Count all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a model that we need to compute distances to
  [in] | threshold | maximum admissible distance threshold for determining the inliers from the outliers

Returns
  the resultant number of inliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 64 of file sac_model_perpendicular_plane.hpp.

## getAxis()

template<typename PointT >

Eigen::Vector3f pcl::SampleConsensusModelPerpendicularPlane< PointT >::getAxis | ( |  | ) | const

inline

Get the axis along which we need to search for a plane perpendicular to.

Definition at line 125 of file sac_model_perpendicular_plane.h.

References pcl::SampleConsensusModelPerpendicularPlane< PointT >::axis_.

Referenced by pcl::SACSegmentation< PointT >::initSACModel().

## getDistancesToModel()

template<typename PointT >

void pcl::SampleConsensusModelPerpendicularPlane< PointT >::getDistancesToModel | ( | const Eigen::VectorXf & | model_coefficients,
|  | std::vector< double > & | distances
| ) |  | const

override virtual

Compute all distances from the cloud data to a given plane model.

Parameters

  [in] | model_coefficients | the coefficients of a plane model that we need to compute distances to
  [out] | distances | the resultant estimated distances

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 78 of file sac_model_perpendicular_plane.hpp.

## getEpsAngle()

template<typename PointT >

double pcl::SampleConsensusModelPerpendicularPlane< PointT >::getEpsAngle | ( |  | ) | const

inline

Get the angle epsilon (delta) threshold.

Definition at line 136 of file sac_model_perpendicular_plane.h.

References pcl::SampleConsensusModelPerpendicularPlane< PointT >::eps_angle_.

Referenced by pcl::SACSegmentation< PointT >::initSACModel().

## getModelType()

template<typename PointT >

pcl::SacModel pcl::SampleConsensusModelPerpendicularPlane< PointT >::getModelType | ( |  | ) | const

inline override virtual

Return a unique id for this model (SACMODEL_PERPENDICULAR_PLANE).

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 168 of file sac_model_perpendicular_plane.h.

References pcl::SACMODEL_PERPENDICULAR_PLANE.

## isModelValid()

template<typename PointT >

bool pcl::SampleConsensusModelPerpendicularPlane< PointT >::isModelValid | ( | const Eigen::VectorXf & | model_coefficients | ) | const

override protected virtual

Check whether a model is valid given the user constraints.

Parameters

  [in] | model_coefficients | the set of model coefficients

Reimplemented from pcl::SampleConsensusModel< PointT >.

Definition at line 93 of file sac_model_perpendicular_plane.hpp.

References pcl::getAngle3D(), and M_PI.

## selectWithinDistance()

template<typename PointT >

void pcl::SampleConsensusModelPerpendicularPlane< PointT >::selectWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold,
|  | Indices & | inliers
| ) |  |

override virtual

Select all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a plane model that we need to compute distances to
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers
  [out] | inliers | the resultant model inliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 49 of file sac_model_perpendicular_plane.hpp.

## setAxis()

template<typename PointT >

void pcl::SampleConsensusModelPerpendicularPlane< PointT >::setAxis | ( | const Eigen::Vector3f & | ax | ) |

inline

Set the axis along which we need to search for a plane perpendicular to.

Parameters

  [in] | ax | the axis along which we need to search for a plane perpendicular to

Definition at line 121 of file sac_model_perpendicular_plane.h.

References pcl::SampleConsensusModelPerpendicularPlane< PointT >::axis_.

Referenced by pcl::SACSegmentation< PointT >::initSACModel().

## setEpsAngle()

template<typename PointT >

void pcl::SampleConsensusModelPerpendicularPlane< PointT >::setEpsAngle | ( | const double | ea | ) |

inline

Set the angle epsilon (delta) threshold.

Parameters

  [in] | ea | the maximum allowed difference between the plane normal and the given axis.

Note
  You need to specify an angle > 0 in order to activate the axis-angle constraint!

Definition at line 132 of file sac_model_perpendicular_plane.h.

References pcl::SampleConsensusModelPerpendicularPlane< PointT >::eps_angle_.

Referenced by pcl::SACSegmentation< PointT >::initSACModel().

## Member Data Documentation

## axis_

template<typename PointT >

Eigen::Vector3f pcl::SampleConsensusModelPerpendicularPlane< PointT >::axis_

protected

The axis along which we need to search for a plane perpendicular to.

Definition at line 181 of file sac_model_perpendicular_plane.h.

Referenced by pcl::SampleConsensusModelPerpendicularPlane< PointT >::getAxis(), and pcl::SampleConsensusModelPerpendicularPlane< PointT >::setAxis().

## eps_angle_

template<typename PointT >

double pcl::SampleConsensusModelPerpendicularPlane< PointT >::eps_angle_

protected

The maximum allowed difference between the plane normal and the given axis.

Definition at line 184 of file sac_model_perpendicular_plane.h.

Referenced by pcl::SampleConsensusModelPerpendicularPlane< PointT >::getEpsAngle(), and pcl::SampleConsensusModelPerpendicularPlane< PointT >::setEpsAngle().

The documentation for this class was generated from the following files:

- pcl/sample_consensus/sac_model_perpendicular_plane.h
- pcl/sample_consensus/impl/sac_model_perpendicular_plane.hpp